/*
 * Licensed to the OpenAirInterface (OAI) Software Alliance under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The OpenAirInterface Software Alliance licenses this file to You under
 * the OAI Public License, Version 1.1  (the "License"); you may not use this
 * file except in compliance with the License. You may obtain a copy of the
 * License at
 *
 *      http://www.openairinterface.org/?page_id=698
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *-------------------------------------------------------------------------------
 * For more information about the OpenAirInterface (OAI) Software Alliance:
 *      contact@openairinterface.org
 */

/*! \file
 \brief
 \author  Keliang DU, BUPT
 \date 2020
 \email: contact@openairinterface.org
 */

#ifndef _ASSOCIATEDQOSFLOWITEM_H_
#define _ASSOCIATEDQOSFLOWITEM_H_

#include "QosFlowIdentifier.hpp"

extern "C" {
#include "Ngap_AssociatedQosFlowItem.h"
}

namespace ngap {

class AssociatedQosFlowItem {
 public:
  AssociatedQosFlowItem();
  virtual ~AssociatedQosFlowItem();

  void setAssociatedQosFlowItem(
      e_Ngap_AssociatedQosFlowItem__qosFlowMappingIndication
          m_qosFlowMappingIndication,
      QosFlowIdentifier* m_qosFlowIdentifier);
  void setAssociatedQosFlowItem(QosFlowIdentifier* m_qosFlowIdentifier);
  bool getAssociatedQosFlowItem(
      long& m_qosFlowMappingIndication,
      QosFlowIdentifier*& m_qosFlowIdentifier);

  bool encode2AssociatedQosFlowItem(
      Ngap_AssociatedQosFlowItem_t* associatedQosFlowItem);
  bool decodefromAssociatedQosFlowItem(
      Ngap_AssociatedQosFlowItem_t* associatedQosFlowItem);

 private:
  QosFlowIdentifier* qosFlowIdentifier;
  long qosFlowMappingIndication;
};

}  // namespace ngap

#endif
